<?php

session_start();

if(!array_key_exists('ExportSetting', $_SESSION)) 
  $_SESSION['ExportSetting'] = $_COOKIE['ExportSetting'];
  
setcookie('ExportSetting', $_SESSION['ExportSetting']);
include('includes/global.php');
include('includes/zip.lib.php');
include('export.php');    
include('addon/make.php');
include('dbc/dbc.php');

ShowPage();

function CheckBox($Name, $Checked = false)
{
  if($Checked) $Checked = ' checked="1"'; else $Checked = '';
  return('<input type="checkbox" value="1" name="'.$Name.'"'.$Checked.' />');
}

function RadioButton($Name, $Value, $Checked = false)
{
  if($Checked) $Checked = ' checked="1"'; else $Checked = '';
  return('<input type="radio" name="'.$Name.'" value="'.$Value.'"'.$Checked.' />');
}

function SelectOption($Name, $Text, $Selected = false)
{
  if($Selected) $Selected = ' selected="1"'; else $Selected = '';
  return('<option type="checkbox" value="'.$Name.'"'.$Selected.'/>'.$Text.'</option>');
}

if(array_key_exists('UserID', $_SESSION) and ($_SESSION['UserID'] != ''))
{
  $DbResult = $Database->SQLCommand('SELECT ExportSetting FROM user WHERE ID='.$_SESSION['UserID']);
  $DbRow = mysql_fetch_assoc($DbResult);
  $ExportSetting = unserialize($DbRow['ExportSetting']);

  //print_r($_POST);
} else 
{
  $ExportSetting = unserialize($_SESSION['ExportSetting']);
}
if(!isset($ExportSetting['users-selection'])) $ExportSetting['users-selection'] = array();
if(!isset($ExportSetting['Diacritics'])) $ExportSetting['Diacritics'] = 1;
if(!isset($ExportSetting['language-cz'])) $ExportSetting['language-cz'] = 1;
if(!isset($ExportSetting['language-sk'])) $ExportSetting['language-sk'] = 1;
if(!isset($ExportSetting['language-other'])) $ExportSetting['language-other'] = 1;
if(!isset($ExportSetting['users-order'])) $ExportSetting['users-order'] = '';
if(!isset($ExportSetting['Export'])) $ExportSetting['Export'] = 'Addon';
if(!isset($ExportSetting['groups'])) $ExportSetting['groups'] = array();

function CreateZipFromDir(&$Zip, $Path, $ZipPath)
{
  //echo($Path.'<br />');
  $FileList = scandir($Path);
  foreach($FileList as $FileName)
  {
	if(file_exists($Path.$FileName) and ($FileName != '.') and ($FileName != '..'))
	{
      //echo($Path.$FileName.'<br />');
	  if(is_dir($Path.$FileName)) CreateZipFromDir($Zip, $Path.$FileName.'/', $ZipPath.$FileName.'/');
      else $Zip->addFile(file_get_contents($Path.$FileName), $ZipPath.$FileName);	
	}          
  }
}

if(!array_key_exists('action', $_GET)) $_GET['action'] = '';
switch($_GET['action'])
{
  case 'result':
    $ExportSetting['Export'] = @$_POST['Export'];
	switch($ExportSetting['Export'])
	{
	  case 'MangosSQLCompressed':
        if(function_exists('gzcompress')) 
        {
		  $TempDir = 'tmp/'.$_SESSION['User'].'/';
		  if(!file_exists($TempDir)) mkdir($TempDir, 0777, true);
          $SaveFilename = $TempDir.'CzWoW_SQL.zip';
          $SQLFilename = 'CzWoW_SQL.sql';        
          $BufferZip = ExportToMangosSQL($ExportSetting);
          $ZipFile = new zipfile();
          $ZipFile->addFile($BufferZip, $SQLFilename);
          $Buffer = $ZipFile->file();
          file_put_contents($SaveFilename, $Buffer);
        } else echo('Funkce pro tvorbu Zip souboru není podporována!');
        echo('<script type="text/javascript" language="JavaScript" charset="utf-8">'.
          'setTimeout("parent.location.href=\''.$SaveFilename.'\'", 1000)'.
          '</script>');
      
        echo('Pokud nezačalo stahování, soubor by mělo jít stáhnout pomocí tohoto odkazu: '. 
          '<a href="'.$SaveFilename.'">CzWoW_SQL.zip</a><br />'.
          'Pokud se vám zdá, že filtr na export nefunguje, vymažte si vyrovnávací paměť prohlížeče a zkuste stáhnout soubor znovu.');
	    break;
	  case 'MangosSQLDirect':
        echo('Vygenerovaný SQL kód: <br /><pre class="SQLCode">');
        echo(htmlspecialchars(ExportToMangosSQL($ExportSetting)));
        echo('</pre>');
  	    break;
	  case 'XMLCompressed':
        if(function_exists('gzcompress')) 
        {
		  $TempDir = 'tmp/'.$_SESSION['User'].'/';
		  if(!file_exists($TempDir)) mkdir($TempDir, 0777, true);
          $SaveFilename = $TempDir.'CzWoW_XML.zip';
          $SQLFilename = 'CzWoW_XML.sql';        
          $BufferZip = ExportToXML($ExportSetting);
          $ZipFile = new zipfile();
          $ZipFile->addFile($BufferZip, $SQLFilename);
          $Buffer = $ZipFile->file();
          file_put_contents($SaveFilename, $Buffer);
        } else echo('Funkce pro tvorbu Zip souboru není podporována!');
        echo('<script type="text/javascript" language="JavaScript" charset="utf-8">'.
          'setTimeout("parent.location.href=\''.$SaveFilename.'\'", 1000)'.
          '</script>');
      
        echo('Pokud nezačalo stahování, soubor by mělo jít stáhnout pomocí tohoto odkazu: '. 
          '<a href="'.$SaveFilename.'">CzWoW_SQL.zip</a><br />'.
          'Pokud se vám zdá, že filtr na export nefunguje, vymažte si vyrovnávací paměť prohlížeče a zkuste stáhnout soubor znovu.');
	    break;
	  case 'XMLDirect':
        echo('Vygenerované XML: <br /><pre class="SQLCode">');
        echo(htmlspecialchars(ExportToXML($ExportSetting)));
        echo('</pre>');
  	    break;
	  case 'Server':
	    if(Licence(LICENCE_ADMIN)) 
		{
		  $Buffer = ExportToMangosSQL($ExportSetting);
          $Database->SelectDatabase($Config['Database']['DatabaseMangos']);    
          $BufferArray = explode("\n", $Buffer);
		  echo('Přenášení dat do serveru...<br />');
          foreach($BufferArray as $Line) 
          {
			$Database->SQLCommand($Line);
			echo('.');
		  }
          echo("<br />Hotovo<br />");
		} else echo('Nemáte oprávnění.');
	    break;
	  case 'Addon':
        if(function_exists('gzcompress')) 
        {
          $TempDir = 'tmp/'.$_SESSION['User'].'/CzWoW/';
	      echo('Generování addonu...<br />');
          MakeAddon($ExportSetting);
          $SaveFilename = 'tmp/'.$_SESSION['User'].'/CzWoW_Addon.zip';          
          $Zip = new zipfile();
		  CreateZipFromDir($Zip, $TempDir, 'CzWoW/');
          $Zip->addFile(file_get_contents('addon/CzWoW/OptionsFrame.xml'), 'CzWoW/OptionsFrame.xml');	
          $Zip->addFile(file_get_contents('addon/CzWoW/CzWoW.xml'), 'CzWoW/CzWoW.xml');	
		  $Zip->addFile(file_get_contents('addon/CzWoW/CzWoW.toc'), 'CzWoW/CzWoW.toc');	
          //$Zip->addFile(file_get_contents('addon/CzWoW/CzWoW.lua'), 'CzWoW/CzWoW.lua');	
		  $Zip->addFile(file_get_contents('addon/CzWoW/GameMenuFrame.xml'), 'CzWoW/GameMenuFrame.xml');	
		  $Zip->addFile(file_get_contents('addon/CzWoW/Localization.lua'), 'CzWoW/Localization.lua');	
		  $Zip->addFile(file_get_contents('addon/ProffBot/ProffBot.toc'), 'ProffBot/ProffBot.toc');	
		  $Zip->addFile(file_get_contents('addon/ProffBot/ProffBot.xml'), 'ProffBot/ProffBot.xml');	
		  $Zip->addFile(file_get_contents('addon/ProffBot/ProffBot.lua'), 'ProffBot/ProffBot.lua');	
		  $Buffer = $Zip->file();
          file_put_contents($SaveFilename, $Buffer);
  		  echo('Hotovo<br /><br />');
        } else echo('Funkce pro tvorbu Zip souboru není podporována!');
        echo('<script type="text/javascript" language="JavaScript" charset="utf-8">'.
          'setTimeout("parent.location.href=\''.$SaveFilename.'\'", 1000)'.
          '</script>');
      
        echo('Pokud nezačalo stahování, soubor by mělo jít stáhnout pomocí tohoto odkazu: '. 
          '<a href="'.$SaveFilename.'">CzWoW_Addon.zip</a><br />'.
          'Pokud se vám zdá, že filtr na export nefunguje, vymažte si vyrovnávací paměť prohlížeče a zkuste stáhnout soubor znovu.');
		echo('<br /><strong>Použití ve hře</strong><br />Menu addonu ve hře vyvoléte povelem /czwow.');
	    break;
	  case 'DBC':
        if(function_exists('gzcompress')) 
        {
          $TempDir = 'tmp/'.$_SESSION['User'].'/dbc/';
	      echo('Generování dbc souborů...<br />');
          ExportToDBC($ExportSetting);
          $SaveFilename = 'tmp/'.$_SESSION['User'].'/CzWoW_DBC.zip';          
          $Zip = new zipfile();
     	  CreateZipFromDir($Zip, $TempDir, 'DBCClientFiles/');
  	      $Buffer = $Zip->file();
          file_put_contents($SaveFilename, $Buffer);
  		  echo('Hotovo<br /><br />');
        } else echo('Funkce pro tvorbu Zip souboru není podporována!');
        echo('<script type="text/javascript" language="JavaScript" charset="utf-8">'.
          'setTimeout("parent.location.href=\''.$SaveFilename.'\'", 1000)'.
          '</script>');
      
        echo('Pokud nezačalo stahování, soubor by mělo jít stáhnout pomocí tohoto odkazu: '. 
          '<a href="'.$SaveFilename.'">CzWoW_DBC.zip</a><br />'.
          'Pokud se vám zdá, že filtr na export nefunguje, vymažte si vyrovnávací paměť prohlížeče a zkuste stáhnout soubor znovu.');
		echo('<br /><strong>Použití ve hře</strong><br />Ze souborů vytvořte MPQ archív a nahrajte ho do hry do podsložky Data/enUS jako patch-enUS-5.MPQ. Hru spusťte pomocí programu WoWMe.exe (WoW Model Editor Fix).');
	    break;
	}
    WriteLog('Generování SQL výstupu: Typ exportu: <b>'.$ExportSetting['Export'].'</b>, Diakritika: <b>'.$ExportSetting['Diacritics'].'</b>', 2);
    break;
  case 'output':
    if(array_key_exists('groups', $_POST)) $ExportSetting['groups'] = $_POST['groups'];
    $ExportSetting['Diacritics'] = array_key_exists('Diacritics', $_POST);
    $ExportSetting['language-cz'] = array_key_exists('language-cz', $_POST);
    $ExportSetting['language-sk'] = array_key_exists('language-sk', $_POST);
    $ExportSetting['language-other'] = array_key_exists('language-other', $_POST);
    echo('<strong>Krok 3. - Typ výstupu</strong><br /><br />');
    echo('<form action="?action=result" method="post">'.
	  '<table width="100%"><tr><td width="50%">'.
      '<fieldset><legend>Forma výstupu</legend>'.
      RadioButton('Export', 'MangosSQLDirect', $ExportSetting['Export'] == 'MangosSQLDirect').'MaNGOS SQL - přímo zobrazit<br />'.
	  RadioButton('Export', 'MangosSQLCompressed', $ExportSetting['Export'] == 'MangosSQLCompressed').'MaNGOS SQL - komprimovaný soubor<br />'.
      RadioButton('Export', 'XMLDirect', $ExportSetting['Export'] == 'XMLDirect').'XML - přímo zobrazit<br />'.
	  RadioButton('Export', 'XMLCompressed', $ExportSetting['Export'] == 'XMLCompressed').'XML - komprimovaný soubor<br />'.
      //RadioButton('Export', 'DBC', $ExportSetting['Export'] == 'DBC').'DBC - komprimovaný soubor<br />'.
	  RadioButton('Export', 'Addon', $ExportSetting['Export'] == 'Addon').'Addon - komprimovaný soubor<br />');
    if(Licence(LICENCE_ADMIN)) 
      echo(RadioButton('Export', 'Server', $ExportSetting['Export'] == 'Server').'Poslat přímo na server (pouze admin)<br />');
	  //echo('
    echo('</fieldset><br /></td><td>Zvolte způsob, jakým mají být získána výstupní data. V případě přímého zobrazení může být do vašeho prohlížeče přenášeno vysoké množství dat, což může vést k jeho přetížení.<br />Addon je potřeba nakopírovat do složky klienta Interface/AddOns a ve hře lze zpřístupnit jeho možnosti pomocí příkazu /czwow.</td></tr></table>');
	echo('<br /><input type="submit" value="Dokončit" />');
	echo('</form>');
	break;
  case 'parameters':
    $ExportSetting['users-order'] = $_POST['users-order'];
    $ExportSetting['users-selection'] = array();
    $UsersList = explode(',', $_POST['users-order']);
	foreach($UsersList as $Index => $Item)
	{
	  if(array_key_exists('user_'.$Item, $_POST)) $ExportSetting['users-selection'][] = $Item;
	}
	//if(array_key_exists('users', $_POST)) $ExportSetting['users'] = $_POST['users'];
    echo('<strong>Krok 2. - Volba parametrů</strong><br /><br />');
    echo('<form action="?action=output" method="post">');
	echo('<table width="100%"><tr><td>');
    echo('<fieldset><legend>Jazyk</legend>'.
      CheckBox('Diacritics', $ExportSetting['Diacritics'] == 1).'Včetně diakritiky<br /><br />');  
    //echo('<input type="checkbox" name="Use" checked="true">Přidat výchovýběr databáze.<br />');

    echo(CheckBox('language-cz', $ExportSetting['language-cz'] == 1).'Český překlad<br />'.
      CheckBox('language-sk', $ExportSetting['language-sk'] == 1).'Slovenský překlad<br />'.
      CheckBox('language-other', $ExportSetting['language-other'] == 1).'Jiné jazyky<br />');
    echo('</fieldset><br /></td><td>Pro správné zobrazení českých znaků ve hře je nutné používat upravené <a href="download/ceske_fonty_do_wow.zip">počeštěné fonty</a>.<br />Vyberte jaké jazyky se mají uvažovat při exportu.</td></tr><tr><td><fieldset><legend>Skupiny textů</legend>');
    echo('<select name="groups[]" size="15" style="width: 400px;" multiple="1">');
    foreach($TranslationTree as $Group)
      if($Group['TablePrefix'] != '')
        echo(SelectOption($Group['Id'], $Group['Name'].' ('.$Group['TablePrefix'].')', in_array($Group['Id'], $ExportSetting['groups'])));

	echo('</select></fieldset><br /></td><td>Vyberte skupiny textů, z kterých bude sestaven export. Přidržením CTRL nebo SHIFT můžete provádět výběr více položek.</td></tr></table><input type="submit" value="Pokračovat" />');
	echo('</form>');
    break;
  default:
    echo('<strong>Krok 1. - Výběr překladatelů</strong><br /><br />');
	echo('<script type="text/javascript" src="style/jquery.js"></script>
<script type="text/javascript" src="style/jquery-ui.js"></script>
<script type="text/javascript">
$(document).ready(function()
{
	$("#users-table").sortable({ items: "tr", sort: SortComplete });	
	$("#users-order").val($("#users-table").sortable(\'toArray\'));
});

function SortComplete()
{
	$("#users-order").val($("#users-table").sortable(\'toArray\'));	
}
</script>');
    echo('<form name="ListUser" action="?action=parameters" method="post">');
    $Query = 'SELECT T.user, T.ID, T.TranslatedCount FROM (SELECT user, ID, (';
    foreach($TranslationTree as $Group)
      if($Group['TablePrefix'] != '')
        $Query .= '(SELECT COUNT(*) FROM '.$Group['TablePrefix'].' WHERE (user = user.ID) AND (Complete = 1) AND (Language <> 0)) + ';
    $Query .= ' 0) AS TranslatedCount FROM `user` ORDER BY user) AS T WHERE T.TranslatedCount > 0 ORDER BY T.TranslatedCount DESC';
    //echo($Query);
	$ID = $Database->SQLCommand($Query);
	
	// Rebuild user order list
	$Users = array();
	while($Line = mysql_fetch_array($ID)) $Users[$Line['ID']] = $Line;
	$UsersOrder = explode(',', $ExportSetting['users-order']);
	foreach($Users as $User)
	  if(!in_array($User['ID'], $UsersOrder)) $UsersOrder[] = $User['ID'];
	foreach($UsersOrder as $Index => $UserId)
	  if(!array_key_exists($UserId, $Users)) unset($UsersOrder[$Index]);
	$ExportSetting['users-order'] = implode(',', $UsersOrder);
	
	echo ('<script type="text/javascript">
	function CheckAll(check) {
		if (check == true) 	ListUser.CheckedAll.checked = ListUser.CheckedAll.checked? false:true;
		');
    foreach($UsersOrder as $UserId)
    	echo ('ListUser.user_'.$UserId.'.checked = ListUser.CheckedAll.checked? true:false;
    	');
	echo ('} </script><span onClick="CheckAll(false)">'.CheckBox('CheckedAll',False).'</span><span onClick="CheckAll(true)"> zatrhnout vše</span>');
	
	
	echo('<table><tr><td>'.
	'<table class="BaseTable" id="users-table" width="100%"><tr><th>Jméno</th><th>Překladů</th><th></th></tr>');
	//print_r($UsersOrder);    
	// Show ordered user list  
    foreach($UsersOrder as $UserId)
	  echo('<tr id="'.$UserId.'"><td><a href="TranslationList.php?user='.$UserId.'&action=userall" title="Zobrazit Všechny jeho přeložené texty">'.$Users[$UserId]['user'].'</a></td><td>'.$Users[$UserId]['TranslatedCount'].
	  '</td><td>'.CheckBox('user_'.$UserId, in_array($UserId, $ExportSetting['users-selection'])).'</td></tr>');
    echo('</table></td><td valign="top">Zvolte ze seznamu uživatele, od kterých chcete načítat překlady a upravte jejich pořadí, takže od uživatelů výše budou brány překlady přednostně.<br />'.
	  'Řádky v tabulce můžete přesouvat metodou uchop a táhni.'.
      '</td></tr></table>'.
	  '<div><input name="users-order" id="users-order" size="100" type="hidden" /><br />');
	echo('<input type="submit" value="Pokračovat" /></div>');
	echo('</form>');
    break;
}

if(array_key_exists('UserID', $_SESSION) and ($_SESSION['UserID'] != ''))
  $Database->SQLCommand('UPDATE user SET ExportSetting = "'.addslashes(serialize($ExportSetting)).'" WHERE ID='.$_SESSION['UserID']);
  else $_SESSION['ExportSetting'] = serialize($ExportSetting);
        
//print_r($ExportSetting);

ShowFooter();      
?>
